package com.company.uuidattr;

import com.company.uuidattr.entity.MyContainer;
import com.company.uuidattr.entity.MyEntity;
import io.jmix.core.DataManager;
import io.jmix.core.Metadata;
import io.jmix.core.SaveContext;
import io.jmix.core.security.SystemAuthenticator;
import org.junit.jupiter.api.AfterAll;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.TestInstance;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.transaction.annotation.Transactional;

import java.util.UUID;

@SpringBootTest
@TestInstance(TestInstance.Lifecycle.PER_CLASS)
@Transactional
class UuidattrApplicationTests {

	@Autowired
	protected Metadata metadata;

	@Autowired
	protected DataManager dataManager;

	@Autowired
	protected SystemAuthenticator authenticator;

	@BeforeAll
	private void beforeTests() {
		authenticator.begin();
	}

	@AfterAll
	private void afterTests() {
		authenticator.end();
	}

	@Test
	void contextLoads() {
	}

	@Test
	void testMyEntity() {
		SaveContext saveContext = new SaveContext();

		MyContainer myContainer = metadata.create(MyContainer.class);
		saveContext.saving(myContainer);

		MyEntity myEntity = metadata.create(MyEntity.class);
		myEntity.setParentId(UUID.randomUUID());
		saveContext.saving(myEntity);

		dataManager.save(saveContext);
	}

}
